﻿-- Author      : Geminior
-- Create Date : 11/13/2012 4:17:50 PM
-- Not presently in use, just another rotation logic as the one used by Simulation Craft
local actions  = {
	tod = {
		id = TouchOfDeathId,
		GetCD = function(cur_id, r)
			if cur_id == TouchOfDeathId then
				return 200
			end
			
			local _, canTod = GetTimeLeft("player", DeathNote, "HELPFUL|PLAYER")
			if not canTod then
				return 200
			end
			if r.chi >= r.todChiCost then
				return GetCooldown(TouchOfDeathId, -tdb.todWait)
			end

			if(tdb.poolTod) then -- if we can Tod now or within the acceptable wait time but lack the chi, pool chi and let chi builders at it
				r.poolChi = GetCooldown(TouchOfDeathId, -tdb.todWait) <= 0
			end
			return 100
		end,
		UpdateResources = function(r)
			r:UseChi(r.todChiCost)
			r:UseTime(1)
		end,
		info = spells["Touch of Death"].name
	},
	fof = {
		id = FistsOfFuryId,
		GetCD = function(cur_id, r)
			if cur_id == FistsOfFuryId then
				return 200
			end
			
			-- if we aren't off cd we don't want to do the calculations below
			local fofcd = GetCooldown(FistsOfFuryId)
			if fofcd > 0 then
				return 100 + fofcd
			end
			
			-- ok we so if fof will cause us to cap energy (runs 4 secs) we dont want it, if we will loose TigerPower we don't want it
			if r.chi > 2 then
				local fofTime = 4 / r.spell_haste
				if (GetTimeLeft("player", TigerPower, "HELPFUL|PLAYER")) < fofTime or r:TimeToEnergy(100) < fofTime then
					return 101
				end
				return 0
			end

			-- ok so do we pool chi? this calculation is then for the next round, so we need to adjust to the expected situation 1 gcd ahead
			-- the expectation is that fof will effectively use 5 seconds (4 + the 1 gcd) and energy will be 40 less than now, hence 140
			-- of course that requires that we actually have 40 energy, if we have atleast 1 chi there are better things to do otherwise it will pool anyway
			if tdb.poolFof then
				local fofTime = 4 / r.spell_haste
				r.poolChi = (GetTimeLeft("player", TigerPower, "HELPFUL|PLAYER")) >= fofTime + (tdb.tpRefresh / 2) and r:TimeToEnergy(140) >= fofTime -- the (tdb.tpRefresh / 2) bit is just to add a resonable time for the user to be able to refresh tp
			end
			return 102
		end,
		UpdateResources = function(r)
			r:UseChi(3)
			r:UseTime(4 / r.spell_haste)
		end,
		info = spells["Fists of Fury"].name
	},
	rsk = {
		id = RisingSunKickId,
		GetCD = function(cur_id, r)
			if cur_id == RisingSunKickId or r.chi < 2 or r.poolChi then
				return 100
			end
			if ((r.chi <= r.chiMax - 2) and r.willCapEnergy) then
				return 101
			end
			
			return GetCooldown(RisingSunKickId)
		end,
		UpdateResources = function(r)
			r:UseChi(2)
			r:UseTime(1)
		end,
		info = spells["Rising Sun Kick"].name
	},
	tpow = {
		id = TigerPalmId,
		GetCD = function(cur_id, r)
			if (cur_id == TigerPalmId or r.chi < 1 or r.poolChi) then -- TODO: poolchi should only be honored if its for tod, not fof
				return 100
			end
			return max(0, (GetTimeLeft("player", TigerPower, "HELPFUL|PLAYER")) - tdb.tpRefresh)
		end,
		UpdateResources = function(r)
			-- If prioritized above cbtp and cbtp procs but tier power buff is about to expire then this may well be suggested but in fact it will be a cbtp when used
			if ((GetTimeLeft("player", ComboBreakerTigerPalm, "HELPFUL|PLAYER")) > 0) then
				r.spec.cbtp = true
				r:UseTime(1)
			else
				r:UseChi(1)
				r:UseTime(1)
			end
		end,
		info = spells["Tiger Power"].name
	},
	tp = {
		id = TigerPalmId,
		GetCD = function(cur_id, r)
			if r.chi < 1 or r.poolChi then
				return 100
			end
			if ((r.chi <= r.chiMax - 2) and r.willCapEnergy) then
				return 101
			end
			return GetCooldown(TigerPalmId)
		end,
		UpdateResources = function(r)
			r:UseChi(1)
			r:UseTime(1)
		end,
		info = spells["Tiger Palm"].name
	},
	cbtp = {
		id = TigerPalmId,
		GetCD = function(cur_id, r)
			if r.spec.cbtp or (GetTimeLeft("player", ComboBreakerTigerPalm, "HELPFUL|PLAYER")) <= 0 then
				return 100
			end
			return 0
		end,
		UpdateResources = function(r)
			r.spec.cbtp = true
			r:UseTime(1)
		end,
		info = spells["Combo Breaker: Tiger Palm"].name
	},
	bok = {
		id = BlackoutKickId,
		GetCD = function(cur_id, r)
			if r.chi < 2 or r.poolChi then
				return 100
			end

			if r.chi >= r.chiMax - 1 and not r.willCapEnergy then
				return 0
			end

			if (r.chi == r.chiMax or r.TimeToEnergy(40) < GetCooldown(RisingSunKickId)) then
				return 0
			end
			
			return 100
		end,
		UpdateResources = function(r)
			r:UseChi(2)
			r:UseTime(1)
		end,
		info = spells["Blackout Kick"].name
	},
	cbbok = {
		id = BlackoutKickId,
		GetCD = function(cur_id, r)
			if r.spec.cbbok or (GetTimeLeft("player", ComboBreakerBlackoutKick, "HELPFUL|PLAYER")) <= 0 then
				return 100
			end

			return 0
		end,
		UpdateResources = function(r)
			r.spec.cbbok = true
			r:UseTime(1)
		end,
		info = spells["Combo Breaker: Blackout Kick"].name
	},
	eh = {
		id = ExpelHarmId,
		GetCD = function(cur_id, r)
			if cur_id ~= ExpelHarmId and r.chi <= r.chiMax - 2  and r:GetPlayerHealthPercentage() < 90 then
				return GetCooldown(ExpelHarmId)
			end
			
			return 100
		end,
		UpdateResources = function(r)
			r:AddChi(2)
			r:UseEnergy(40) -- time use included
		end,
		info = spells["Expel Harm"].name,
	},
	jab = {
		id = JabId,
		GetCD = function(cur_id, r)
			if r.chi <= r.chiMax - 2 then
				return 0
			end
			return 100
		end,
		UpdateResources = function(r)
			local chiGain = (r.pscd == 0) and 3 or 2
			r:AddChi(chiGain)
			r:UseEnergy(40) -- time use included
		end,
		info = spells["Jab"].name,
	},
	eb = {
		id = EnergizingBrewId,
		GetCD = function(cur_id, r)
			if cur_id == EnergizingBrewId or (r:TimeToEnergy(100) < tdb.useEbTh) then
				return 100
			end
			
			return GetCooldown(EnergizingBrewId)
		end,
		UpdateResources = function(r)
			r:BoostEnergy(10)
		end,
		info = spells["Energizing Brew"].name,
	},
	teb = {
		id = TigereyeBrewId,
		GetCD = function(cur_id, r)
			if cur_id == TigereyeBrewId then
				return 100
			end

			local t, stacks = GetTimeLeft("player", TigereyeBrew, "HELPFUL|PLAYER")
			if (stacks and (stacks >= tdb.useTebAt or (stacks > 0 and t < 4))) then -- the buff is the same name when active but with 0 stacks hence the latter check
				return GetCooldown(TigereyeBrewId)
			end

			return 100
		end,
		info = spells["Tigereye Brew"].name,
	},
	fsk = {
		id = FlyingSerpentKickId,
		GetCD = function(cur_id, r)
			if cur_id == FlyingSerpentKickId then
				return 0
			end
			return GetCooldown(FlyingSerpentKickId) + 1 --yeah so hardcoded this one. Basically we don't want to use this unless all other options are unavailable for atleast the time it takes to get this off and land again
		end,
		info = spells["Flying Serpent Kick"].name,
	},
	
}