﻿-- Author      : Geminior
-- Create Date : 11/8/2012 7:47:50 PM
-- Temporary overides of clcInfo core functions until the functionality is implemented


if not clcInfo then return end       -- need clcInfo to run
if not clcInfo_Monk then return end

function clcInfo:ReadSavedData()
	-- global defaults
	if not clcInfoDB then
		clcInfoDB = {}
	end
	clcInfo.db = clcInfoDB	

	-- perchar defaults
	if not clcInfoCharDB then
		clcInfoCharDB = clcInfo:GetDefault()
		for k, v in pairs(clcInfo.classModules) do
			if v.CreateDefaultTemplate then
				table.insert(clcInfoCharDB.templates, v:CreateDefaultTemplate())
			end
		end
		if #clcInfoCharDB.templates == 0 then
			table.insert(clcInfoCharDB.templates, clcInfo.templates:GetDefault())
		end
	end
	clcInfo.cdb = clcInfoCharDB
end

local originalLoadActiveTemplate
local function OverrideLoadActiveTemplate()
	originalLoadActiveTemplate = clcInfo_Options.LoadActiveTemplate
	clcInfo_Options.LoadActiveTemplate = function(self)
		originalLoadActiveTemplate(self)
		if not clcInfo.activeTemplate then
			self:LoadClassModules()
		end
	end
end

function clcInfo_Monk.ADDON_LOADED(self, event, ...)
	local addon = ...
	if addon == "clcInfo_Options" then
		OverrideLoadActiveTemplate()
		clcInfo_Monk.EventFrame:UnregisterEvent("ADDON_LOADED")
	end
end

if clcInfo_Options then
	OverrideLoadActiveTemplate()
else
	clcInfo_Monk.EventFrame:RegisterEvent("ADDON_LOADED")
end