﻿------------------------------------------------------------------------------
-- $Id$
------------------------------------------------------------------------------
--                                templates.lua
--
--    Copyright (C) 2012 Geminior
--
--  This program is free software: you can redistribute it and/or modify
--  it under the terms of the GNU Lesser General Public License as published
--  by the Free Software Foundation, either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU Lesser General Public License
--  along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
--  This file is for use with clcInfo by abija.  To a great extend this is based on the clcInfo_Rogue by Deronda.

--  abija has distributed clcInfo All Rights Reserved.  For more information
--  go to: http://wow.curseforge.com/addons/clctracker/
--
------------------------------------------------------------------------------
-- Author:
--      Geminior (@ Earthen Ring)
------------------------------------------------------------------------------
-- Description:
--   Templates for clcInfo_Monk
--------------------------------------------------------------------------------
-- loader
if not clcInfo then return end
if not clcInfo_Monk then return end

clcInfo.optionsCMLoaders[#(clcInfo.optionsCMLoaders) + 1] = function()
    -- don't load if class is wrong
    local _, englishClass = UnitClass("player")
    if englishClass ~= clcInfo_Monk.CLASS then return end
    if not clcInfo_Options then return end

    local mod = clcInfo_Options.templates
    local defs = mod.defs
    local format = string.format
    
    local spells = clcInfo_Monk.spells

    local name
    
    --Icons-----------------------------------------------------------
 
    -- Generic Monk -------------------------------------------------
    local basic_cds = clcInfo_Monk.basic_cds
    -- get the localized names and make cd templates  
    for key, value in pairs(basic_cds) do
        name = GetSpellInfo(value)
        if not name then name = "Unknown Spell" end
        mod:Add("icons", defs.CLASS, name, format([[
        return IconSpell("%s")
        ]], name))
    end

    -- Brewmaster--------------------------------------------------
	name = spells["Elusive Brew"].name
    mod:Add("icons", defs.CLASS_1, name, "return ElusiveBrewIcon()")

	-- Windwalker--------------------------------------------------
	name = spells["Tigereye Brew"].name
    mod:Add("icons", defs.CLASS_3, name, "return TigerEyeBrewIcon()")
	
    --Bars------------------------------------------------------------
    -- Generic Monk --------------------------------------------------
    
    --Energy
    name = ENERGY
    mod:Add("bars", defs.CLASS, name, format([[
    local nrg = UnitPower("player")
    return true, "Interface/ICONS/INV_Sigil_Thorim", 0, UnitPowerMax("player"),
           nrg, nil, "%s", nil, nrg
    ]], name))  
    
 
    -- Brewmaster--------------------------------------------------
    
    --Light Stagger
    name = spells["Light Stagger"].name
    mod:Add("bars", defs.CLASS_1, name, format([[
    return BarAura("HARMFUL", "player", "%s", nil, false, true)
    ]], name))
    
    --Moderate Stagger
    name = spells["Moderate Stagger"].name
    mod:Add("bars", defs.CLASS_1, name, format([[
    return BarAura("HARMFUL", "player", "%s", nil, false, true)
    ]], name))    
    
    --Heavy Stagger
    name = spells["Heavy Stagger"].name
    mod:Add("bars", defs.CLASS_1, name, format([[
    return BarAura("HARMFUL", "player", "%s", nil, false, true)
    ]], name))
    
  
    -- Priorities
    ----------------------------------------------------------------------------
    -- Brewmaster Priorities
    local _, specialization_name = GetSpecializationInfo(1)
    mod:Add("icons", defs.CLASS_1, format("%s %s: %s", specialization_name,
            COMBATLOG_HIGHLIGHT_ABILITY, REFORGE_CURRENT),
            "return IconBrewmasterCurrent()")
    mod:Add("icons", defs.CLASS_1, format("%s %s: %s", specialization_name,
            COMBATLOG_HIGHLIGHT_ABILITY, NEXT), "IconBrewmasterNext()")

	-- Windwalker Priorities
    local _, specialization_name = GetSpecializationInfo(3)
    mod:Add("icons", defs.CLASS_3, format("%s %s: %s", specialization_name,
            COMBATLOG_HIGHLIGHT_ABILITY, REFORGE_CURRENT),
            "return IconWindwalkerCurrent()")
    mod:Add("icons", defs.CLASS_3, format("%s %s: %s", specialization_name,
            COMBATLOG_HIGHLIGHT_ABILITY, NEXT), "IconWindwalkerNext()")
end